码迷,mamicode.com
首页 > 其他好文 > 详细

[LeetCode] Two Sum

时间:2015-08-18 13:48:33      阅读:106      评论:0      收藏:0      [点我收藏+]

标签:

Given an array of integers, find two numbers such that they add up to a specific target number.

The function twoSum should return indices of the two numbers such that they add up to the target, where index1 must be less than index2. Please note that your returned answers (both index1 and index2) are not zero-based.

You may assume that each input would have exactly one solution.

Input: numbers={2, 7, 11, 15}, target=9
Output: index1=1, index2=2

 

     这道排在第一位置的题我却现在才做,别的不说了。这个用HashMap即可轻松解决。

     不过注意的是,因为不能return 0.但是直接用map.get()method的话是有可能产生0的,所以return的i都要+1。

     代码如下。~

public class Solution {
    public int[] twoSum(int[] nums, int target) {
        HashMap<Integer,Integer> result=new HashMap<>();
        for(int i=0;i<nums.length;i++){
            if(result.containsKey(target-nums[i])){
                return new int[]{result.get(target-nums[i])+1,i+1};
            }else{
                result.put(nums[i],i);
            }
        }
       return null;
    }
}

 

[LeetCode] Two Sum

标签:

原文地址:http://www.cnblogs.com/orangeme404/p/4739093.html

(0)
(0)
   
举报
评论 一句话评论(0
登录后才能评论!
© 2014 mamicode.com 版权所有  联系我们:gaon5@hotmail.com
迷上了代码!